Strict

Import BRL.FreeAudioAudio
Import BRL.WavLoader

?Win32
Import "bass.bmx"
?

Global sfxvol# = 0.5
Global musicvol# = 0.5
?Mac
Global musicchannel:TChannel = Null
?Win32
Global musicchannel:Int = 0
?Linux
Global musicchannel:TChannel = Null
?


Global sunloopchan:TChannel[]
sunloopchan = New TChannel[8]


' snds
Global nme_born_snd:TSound = LoadSound("sounds/buzz3.wav")			' 
Global nme1_born_snd:TSound = LoadSound("sounds/pop2.wav")			' 
Global nme2_born_snd:TSound = LoadSound("sounds/pop3.wav")			' 
Global nme3_born_snd:TSound = LoadSound("sounds/snake1.wav")			' 
Global nme4_born_snd:TSound = LoadSound("sounds/gruntborn.wav")			' 

Global nme5_born_snd:TSound = LoadSound("sounds/sun1.wav")			' 
Global nme5_loop_snd:TSound = LoadSound("sounds/bondloop.wav",True)			' 
Global nme5_shrink_snd:TSound = LoadSound("sounds/sunhit1.wav")			' 
Global nme5_grow_snd:TSound = LoadSound("sounds/sizzle1.wav")		' 
Global nme5_explode_snd:TSound = LoadSound("sounds/sunexp.wav")			' 
Global nme5_killed_snd:TSound = LoadSound("sounds/Explo1.wav")			' 

Global nme6_born_snd:TSound = LoadSound("sounds/wee.wav")
Global nme6_tailexplode_snd:TSound = LoadSound("sounds/snakehit.wav")
Global nme6_tailhit_snd:TSound = LoadSound("sounds/tailhit.wav")

Global nme7_born_snd:TSound = LoadSound("sounds/warn1.wav")			' 
Global nme7_shield_snd:TSound = LoadSound("sounds/shield1.wav")			' 

Global nme8_born_snd:TSound = LoadSound("sounds/butterfly.wav")			' 

Global ge_born_snd:TSound = LoadSound("sounds/cat.wav")			' 
Global ge_hit_snd:TSound = LoadSound("sounds/genhit1.wav")		
Global ge_killed_snd:TSound = LoadSound("sounds/genkilled1.wav")		'

Global le_born_snd:TSound = LoadSound("sounds/buzz1.wav")			' 
Global le_hit_snd:TSound = LoadSound("sounds/echo1.wav")			
Global le_killed_snd:TSound = LoadSound("sounds/elastic.wav")		'

Global pu_collect_snd:TSound = LoadSound("sounds/bonus1.wav")		' 

Global get_ready_snd:TSound = LoadSound("sounds/startup.wav")			' 

Global player_hit_snd:TSound = LoadSound("sounds/die1.wav")		' 

Global shot_born_snd:TSound = LoadSound("sounds/shotborn.wav")			' 
Global shot_hit_wall_snd:TSound = LoadSound("sounds/shotwall.wav")			' 

Global game_over_snd:TSound = LoadSound("sounds/gameover.wav")			' 

Global super_bomb_snd:TSound = LoadSound("sounds/explo1.wav")			' 

Global extra_life_snd:TSound = LoadSound("sounds/brainborn.wav")			' 

Global extra_bomb_snd:TSound = LoadSound("sounds/buzz2.wav")			' 

Global multiplier_increase_snd:TSound = LoadSound("sounds/bonus2.wav")		' 
Global bonus_born_snd:TSound = LoadSound("sounds/bonusborn.wav")		' 
Global high_score_snd:TSound = LoadSound("sounds/bonus1.wav")		' reused

Global quarkhitsound:TSound = LoadSound("sounds/quarkhit.wav")		' 
Global quarkhit2sound:TSound = LoadSound("sounds/quarkhit2.wav")		' 


Function PlaySound2:TChannel(snd:TSound, freq# = 1, pan#=0, vol# = 1)

	Local ch:TChannel = Null
	
	If sfxvol > 0
		ch=CueSound(snd)
		If freq <> 1
			SetChannelRate(ch,freq)
		EndIf
		SetChannelPan ch, pan		
		SetChannelVolume ch,sfxvol*vol
		ResumeChannel ch	
	EndIf
	Return ch

End Function


Function SetPanAndVolume(ch:TChannel, pan#, vol#)

	If ch <> Null
		If sfxvol > 0
			SetChannelPan ch, pan		
			SetChannelVolume ch,sfxvol*vol
		EndIf
	EndIf

End Function



Function AdjustVolume()
	Local t:Int
	
	For t = 0 To 7
		If sunloopchan[t] <> Null
			SetChannelVolume sunloopchan[t],sfxvol
		EndIf
	Next

End Function


Function StopLoopingSounds()
	Local t:Int
	
	For t = 0 To 7
		If sunloopchan[t] <> Null
			StopChannel(sunloopchan[t])
			sunloopchan[t] = Null
		EndIf
	Next

End Function


Function StartMusic(song:Int)
?MacOS
'need a way to play tunes on a mac
'ogg maybe?
Rem
	If musicchannel <> Null Then Return
	
	Local f$ = ""

	Select song
		Case 0 'intro
			f$ = "music/Theme0.ogg"
		Case 1 'in game
			f$ = "music/Theme1.ogg"	
		Case 2 'hi score
			f$ = "music/Theme2.ogg"
	End Select
		
	musicchannel = CueSound(LoadSound(f$))
	SetChannelVolume(musicchannel,musicvol)
	ResumeChannel(musicchannel)
EndRem

?Win32
	If musicchannel <> 0 Then Return
	
	Local f$ = ""

	Select song
		Case 0 'intro
			f$ = "music/Theme0.it"
		Case 1 'in game
			f$ = "music/Theme1.it"	
		Case 2 'hi score
			f$ = "music/Theme2.it"
	End Select
		
	BASS_Free()	
	Local dev:Int = BASS_Init(1,44100,0,0,0)
	If dev <> 0
		musicchannel = BASS_MusicLoad(False,f$,0,0,BASS_SAMPLE_LOOP Or BASS_MUSIC_RAMPS Or BASS_MUSIC_CALCLEN,0)
		BASS_ChannelSetAttributes(musicchannel,-1,100*musicvol,-1)
		BASS_ChannelPlay(musicchannel,False)
	EndIf
?

?Linux

?	
	
			
End Function


Function StopMusic()
?MacOS
'need a way to play tunes on a mac
'ogg maybe?
Rem
	If musicchannel <> Null
		StopChannel(musicchannel)
		musicchannel = 0
	EndIf
End Rem
?Win32
	If musicchannel <> 0
		BASS_ChannelStop(musicchannel)
		BASS_Free()
		musicchannel = 0
	EndIf
?
?Linux

?	

End Function


Function SetMusicVolume()
?Mac
'need a way to play tunes on a mac
'ogg maybe?
Rem
	If musicchannel <> Null
		SetChannelVolume(musicchannel,musicvol)
	EndIf
End Rem
?Win32
	If musicchannel <>0
		BASS_ChannelSetAttributes(musicchannel,-1,100*musicvol,-1)
	EndIf
?
?Linux

?	

End Function

